import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class ConsiderateWindow extends JComponent implements ActionListener {

  private static ConsiderateWindow window;

  public static ConsiderateWindow getWindow() {
    if (window == null) {
      window = new ConsiderateWindow();
    }
    return window;
  }

  private boolean running;
  private int     count;

  private JFrame  frame;
  private JButton button;
  private JLabel  countDisplay;

  private ConsiderateWindow() {
    super();

    setLayout(new FlowLayout());

    button = new JButton();
    button.setText("Click to Begin");

    button.addActionListener( this );

    countDisplay = new JLabel();
    countDisplay.setText("0");

    add(button);
    add(countDisplay);

    frame = new JFrame("Don't Click the Button");
    frame.setSize(400, 400);
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.add( this );

    frame.pack();

    frame.setVisible(true);

  }

  public void actionPerformed(final ActionEvent event) {
    if (running) {
      stopProcess();
    } else {
      new Thread(
        new Runnable() {
          public void run() {
            try {
              startProcess();
            } catch (Exception ex) {
            }
          }
        }
      ).start();
    }
  }

  private void startProcess() throws Exception {
    running = true;
    SwingUtilities.invokeAndWait(
      new Runnable() {
        public void run() {
          button.setText("I told you not to click the button!");
          frame.pack();
        }
      }
    );
    while (running) {
      count++;
      System.out.println("count = " + count);
      SwingUtilities.invokeAndWait(
        new Runnable() {
          public void run() {
            countDisplay.setText("" + count);
            frame.pack();
          }
        }
      );
      try {
        Thread.sleep(1000);
      } catch (Exception ex) {
      }
    }
    SwingUtilities.invokeAndWait(
      new Runnable() {
        public void run() {
          count = 0;
          button.setText("Don't Click the Button");
          countDisplay.setText("0");
          frame.pack();
        }
      }
    );
  }

  private void stopProcess() {
    running = false;
  }

}
