import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class SelfishWindow extends JComponent implements ActionListener {

  private static SelfishWindow window;

  public static SelfishWindow getWindow() {
    if (window == null) {
      window = new SelfishWindow();
    }
    return window;
  }

  private boolean running;
  private int     count;

  private JFrame  frame;
  private JButton button;
  private JLabel  countDisplay;

  private SelfishWindow() {
    super();

    setLayout(new FlowLayout());

    button = new JButton();
    button.setText("Click to Begin");

    button.addActionListener( this );

    countDisplay = new JLabel();
    countDisplay.setText("0");

    add(button);
    add(countDisplay);

    frame = new JFrame("Don't Click the Button");
    frame.setSize(400, 400);
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.add( this );

    frame.pack();

    frame.setVisible(true);

  }

  public void actionPerformed(final ActionEvent event) {
    if (running) {
      stopProcess();
    } else {
      startProcess();
    }
  }

  private void startProcess() {
    button.setText("I told you not to click the button!");
    frame.pack();
    running = true;
    while (running) {
      count++;
      System.out.println("count = " + count);
      countDisplay.setText("" + count);
      frame.pack();
      try {
        Thread.sleep(1000);
      } catch (Exception ex) {
      }
    }
  }

  private void stopProcess() {
    button.setText("Don't Click the Button");
    countDisplay.setText("0");
    frame.pack();
    running = false;
  }

}
